routes/web.php
<?php

/*Route::get('/', function () {
    return view('welcome');
})->name('home');*/
Route::get('/', 'Auth\LoginController@home')->name('home');


Route::get('auth/google', 'Auth\LoginController@redirectToProviderGoogle')->name('googleLogin');
Route::get('auth/google/callback', 'Auth\LoginController@handleProviderCallbackGoogle');

Route::get('auth/facebook', 'Auth\LoginController@redirectToProviderFacebook')->name('facebookLogin');
Route::get('auth/facebook/callback', 'Auth\LoginController@handleProviderCallbackFacebook');

Route::group(['middleware' => ['web', 'auth']], function(){

    Route::get('logout','Auth\LoginController@logout')->name('getlogout');
    Route::get('profile', 'UserController@profile')->name('getprofile');

});

Route::group(['middleware' => ['web','auth','writer']], function(){
    
    Route::resource('article','ArticleController');
    Route::post('article/upload','ArticleController@upload')->name('article.upload');
    Route::delete('article/{image}','ArticleController@destroyUpload')->name('image.destroy');
    Route::get('article/bookmark/{article}','ArticleController@bookmark')->name('article.bookmark');

    //Personal Routes
    Route::get('personal/draft','UserController@draft')->name('personal.draft');
    Route::get('personal/bookmark','UserController@bookmarks')->name('personal.bookmark');
    Route::get('personal/published','UserController@published')->name('personal.published');

    //Interest Controller
    Route::get('interest','InterestController@index')->name('interest.index');
    Route::post('interest/subscribe','InterestController@subscribe')->name('interest.subscribe');

    //Follow
    Route::get('follow','UserController@follow')->name('user.follow');
    Route::post('startfollowing','UserController@startFollowing')->name('user.followstart');

    Route::get('board','UserController@index')->name('getboard');

});

Route::group(['prefix' => 'admin', 'middleware' => ['web','auth','admin']],function(){

    Route::get('board','UserController@index')->name('admin.getboard');


   /* Route::get('board',function(){
      return view('welcome');
   })->name('admin.getboard');*/

});

app/Http/Controllers/ArticleController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Feed;
use Illuminate\Support\Facades\Auth;
use App\Models\Bookmark;
use App\Models\Interest;

class ArticleController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Request $request)
    {
        $tags = Interest::all();
        return view('article.create',compact('tags'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */

    public function store(Request $request)
    {
        $this->validate($request,[
            'title' => 'required|min:20|unique:feeds,title|max:200',
            'content' => 'required|min:30',
            'interest_id' => 'required|exists:interests,id'
/*            'featured_image' => 'nullable|active_url'*/
        ]);
        $body = $request->all();
        $body['user_id'] = Auth::user()->id;
        $feed = Feed::create($body);
        return response()->json($feed);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Feed $article)
    {
        return view('article.index',compact('article'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $feed = Feed::where(['user_id' => Auth::user()->id, 'id' => $id])->firstOrFail();
        return view('article.edit',compact('feed'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $this->validate($request,[
            'title' => 'required|min:20|max:200',
            'content' => 'required|min:30',
            /*            'featured_image' => 'nullable|active_url'*/
        ]);
        $feed = Feed::where(['user_id' => Auth::user()->id, 'id' => $id])->firstOrFail();
        $feed->update($request->all());
        return response()->json(['message' => 'success']);


    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $feed = Feed::where(['user_id' => Auth::user()->id, 'id' => $id])->firstOrFail();
        $feed->delete();
        return response()->json(['message' => 'deleted']);
    }

    //upload Article Media
    public function upload(Request $request)
    {
        if ($request->hasFile('files')) {
            $files = $request->file('files');
            foreach ($files as $file) {
                $type = $file->getMimeType();
                $size = $file->getClientSize();
                $filename = time() . '-' . $file->getClientOriginalName();
                $file->move(public_path('uploads/post'),$filename);
                $fileUrl = url('/uploads/post/'. $filename);

                $uploadedFiles['files'][] = ['url' => $fileUrl, 'thumbnail_url' => $fileUrl, 'name' => $filename, 'type' => $type, 'size' => $size, 'delete_url' => route('image.destroy',['image' => $filename]), 'delete_type'=> "DELETE" ];
            }

            return $uploadedFiles;
        }else{
            echo 'file not found';
        }
    }

    //Destroy Uploaded Media
    public function destroyUpload(Request $request ,$file)
    {
        $filePath = public_path() . '/uploads/post/'. $file;
        if(file_exists($filePath)) {
            unlink($filePath);
            return response()->json('success');
        } else {
            return response()->json('error',404);
        }
    }

    //Bookmark feed
    public function bookmark(Feed $article)
    {
        Bookmark::firstOrCreate(['user_id' => Auth::id(), 'feed_id' => $article->id]);
        return response()->json(['message' => 'success']);
    }
}

resources/views/article/create.blade.php
@extends('layouts.app')

@section('page-title', 'Upsider - Write A New Article')

@section('page-css')
    <link href="http://netdna.bootstrapcdn.com/font-awesome/4.0.3/css/font-awesome.css" rel="stylesheet">
    <link rel="stylesheet" href="{{ asset('node_modules/medium-editor/dist/css/medium-editor.min.css') }}">
    <link rel="stylesheet" href="{{ asset('node_modules/medium-editor/dist/css/themes/default.css') }}">
    <link rel="stylesheet" href="{{ asset('node_modules/medium-editor-insert-plugin/dist/css/medium-editor-insert-plugin.min.css') }}">
@endsection


@section('page-content')

    <div class="container">
        <div class="row">
            <div class="col-sm-12">
                <div class="form-group">
                    <label class="control-label col-sm-2" for="name">Tags</label>
                    <div class="col-sm-3">
                        <select class="form-control" id="tag" >
                            @forelse($tags as $tag)
                                <option value="{{ $tag->id }}">{{ $tag->name}}</option>
                            @empty
                                <option value="">No Tags</option>
                            @endforelse
                        </select>
                    </div>
                </div>

                <div class="pull-right">
                    Featured Image: <input id="fileupload" type="file" name="files[]"  multiple>
                    <img id="uploadPreview" />
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-sm-12">
                <div class="panel panel-default">
                    <div class="panel-heading"><h3 class="panel-title">New Post</h3></div>
                    <div class="panel-body">

                            <div class="form-group">
                                <label class="col-md-2 control-label">Post Title</label>
                                <div class="col-md-10">
                                    <input type="text" name="title" class="form-control" id="post-title">
                                    <input type="hidden" id="featured_image">
                                </div>
                            </div>
                        <br>
                        <br>

                            <div class="form-group">
                                <label class="col-md-2 control-label">Content</label>
                                <div class="col-md-10">
                                    <div class="editable" id="post-body"></div>
                                    {{--<textarea class="form-control editable" rows="5"></textarea>--}}
                                </div>
                            </div>

                            <div class="form-group m-b-0 ">
                                <div class="col-sm-offset-3 col-sm-9 m-t-40">
                                    <button type="button" class="btn btn-info waves-effect waves-light" onclick="savePost('draft')">Save as Draft</button>
                                </div>
                                <div class="col-sm-offset-3 col-sm-9 m-t-40">
                                    <button type="button" class="btn btn-info waves-effect waves-light" onclick="savePost('published')">Publish Post</button>
                                </div>
                            </div>

                    </div> <!-- panel-body -->
                </div> <!-- panel -->
            </div> <!-- col -->
        </div> <!-- End row -->

        <div id="article-content" style="display: none;">

        </div>

    </div> <!-- container -->

@endsection

@section('page-js')

    <script src="{{ asset('node_modules/medium-editor/dist/js/medium-editor.js') }}"></script>
    <script src="{{ asset('node_modules/handlebars/dist/handlebars.runtime.min.js') }}"></script>
    <script src="{{ asset('node_modules/jquery-sortable/source/js/jquery-sortable-min.js') }}"></script>
    <script src="{{ asset('node_modules/blueimp-file-upload/js/vendor/jquery.ui.widget.js') }}"></script>
    <script src="http://linkesch.com/medium-editor-insert-plugin/bower_components/jquery-cycle2/build/jquery.cycle2.min.js"></script>
    <script src="http://linkesch.com/medium-editor-insert-plugin/bower_components/jquery-cycle2/build/plugin/jquery.cycle2.center.min.js"></script>
    <script src="https://blueimp.github.io/JavaScript-Load-Image/js/load-image.js"></script>
    <script src="http://blueimp.github.io/JavaScript-Canvas-to-Blob/js/canvas-to-blob.min.js"></script>
    <script src="{{ asset('node_modules/blueimp-file-upload/js/jquery.iframe-transport.js') }}"></script>
    <script src="{{ asset('node_modules/blueimp-file-upload/js/jquery.fileupload.js') }}"></script>
    <script src="{{ asset('node_modules/medium-editor-insert-plugin/dist/js/medium-editor-insert-plugin.min.js') }}"></script>

    <script type="text/javascript">

        var editor = new MediumEditor('.editable');

        $(function () {
            $('.editable').mediumInsert({
                editor: editor,
                addons: { // (object) Addons configuration
                    images: { // (object) Image addon configuration
                        label: '<span class="fa fa-camera"></span>', // (string) A label for an image addon
                        fileDeleteOptions: {}, // (object) extra parameters send on the delete ajax request, see http://api.jquery.com/jquery.ajax/
                        preview: true, // (boolean) Show an image before it is uploaded (only in browsers that support this feature)
                        captions: true, // (boolean) Enable captions
                        autoGrid: 3, // (integer) Min number of images that automatically form a grid
                        formData: {}, // DEPRECATED: Use fileUploadOptions instead
                        fileUploadOptions: { // (object) File upload configuration. See https://github.com/blueimp/jQuery-File-Upload/wiki/Options
                            url: '{{ route('article.upload') }}', // (string) A relative path to an upload script
                            limitMultiFileUploads:2,
                            acceptFileTypes: /(\.|\/)(gif|jpe?g|png)$/i // (regexp) Regexp of accepted file types
                        },
                        styles: { // (object) Available image styles configuration
                            wide: { // (object) Image style configuration. Key is used as a class name added to an image, when the style is selected (.medium-insert-images-wide)
                                label: '<span class="fa fa-align-justify"></span>', // (string) A label for a style
                                added: function ($el) {
                                }, // (function) Callback function called after the style was selected. A parameter $el is a current active paragraph (.medium-insert-active)
                                removed: function ($el) {
                                } // (function) Callback function called after a different style was selected and this one was removed. A parameter $el is a current active paragraph (.medium-insert-active)
                            },
                            left: {
                                label: '<span class="fa fa-align-left"></span>'
                            },
                            right: {
                                label: '<span class="fa fa-align-right"></span>'
                            },
                            grid: {
                                label: '<span class="fa fa-th"></span>'
                            }
                        },
                        actions: { // (object) Actions for an optional second toolbar
                            remove: { // (object) Remove action configuration
                                label: '<span class="fa fa-times"></span>', // (string) Label for an action
                                clicked: function ($el) { // (function) Callback function called when an action is selected
                                    var $event = $.Event('keydown');

                                    $event.which = 8;
                                    $(document).trigger($event);
                                }
                            }
                        },
                        messages: {
                            acceptFileTypesError: 'This file is not in a supported format: ',
                            maxFileSizeError: 'This file is too big: '
                        },
                        uploadCompleted: function ($el, data) {
                            console.log(data);
                        }, // (function) Callback function called when upload is completed
                        uploadFailed: function (uploadErrors, data) {
                            console.log(data);

                        } // (function) Callback function called when upload failed
                    }
                }
            });
        });

        function savePost(status)
        {
            var minLength = 300;
            var category;
            var postContent = editor.serialize();

            $('#article-content').html(postContent['post-body']['value']);
            var numImg = $('#article-content img').length;
            var numIframe = $('#article-content iframe').length;
            var contentLength = $('#article-content').text().length;

            if(contentLength == 0)
            {
                notify('Content Must not Be Empty!','error');
                return false;
            }

            console.log(numImg, contentLength, numIframe);

            if(numIframe > 0){
                category = 'video';
            } else if(contentLength > minLength){
                category = 'story';
            }else{
                category = 'photo';
            }

            var data = {
                title: $('#post-title').val(),
                content: postContent['post-body']['value'],
                category : category,
                featured_image: $('#featured_image').val(),
                status:status,
                interest_id:$('#tag').val()
            };

            console.log(data);

            $.ajax({
                type: 'POST',
                dataType: 'json',
                url : "{{ route('article.store') }}",
                data: data,
                success: function(data) {
                    console.log(data);
                    location.href = '{{ route('getboard')  }}';
                },
                error: function(response) {
                    handleInputErrors(response.responseText);
                }
            });
        }

        /*$('body').on('click', '#save-post', function(e){
            e.preventDefault();


            return false;
        });*/

        //Featured Image Preview.
        $("#fileupload").change(function(){
            readURL(this);
        });

        //upload Featured Image.
        $(function () {
            $('#fileupload').fileupload({
                url: '{{ route('article.upload') }}',
                dataType: 'json',
                done: function (e, data) {
                    notify('Featured Image Uploaded Successfully!','success');
                    console.log(data);
                    $('#featured_image').val(data.result.files[0].url);
                }
            });
        });

    </script>

@endsection

resources/views/article/edit.blade.php
@extends('layouts.app')

@section('page-title', 'Upsider - Update Article')

@section('page-css')
    <link href="http://netdna.bootstrapcdn.com/font-awesome/4.0.3/css/font-awesome.css" rel="stylesheet">
    <link rel="stylesheet" href="{{ asset('node_modules/medium-editor/dist/css/medium-editor.min.css') }}">
    <link rel="stylesheet" href="{{ asset('node_modules/medium-editor/dist/css/themes/default.css') }}">
    <link rel="stylesheet" href="{{ asset('node_modules/medium-editor-insert-plugin/dist/css/medium-editor-insert-plugin.min.css') }}">
@endsection


@section('page-content')

    <div class="container">

        <div class="row">
            <div class="col-sm-12">
                <input id="fileupload" type="file" name="files[]"  multiple>
                @if($feed->featured_image)
                    <img id="uploadPreview" href="{{ $feed->featured_image }}" style="height: 150px; width: 150px;"/>
                @else
                    <img id="uploadPreview" />
                @endif
                <div class="panel panel-default">
                    <div class="panel-heading"><h3 class="panel-title">Edit Post</h3></div>
                    <div class="panel-body">

                        <div class="form-group">
                            <label class="col-md-2 control-label">Post Title</label>
                            <div class="col-md-10">
                                <input type="text" name="title" class="form-control" id="post-title" value="{{ $feed->title }}">
                                <input type="hidden" id="featured_image" value="{{ $feed->featured_image }}">
                            </div>
                        </div>
                        <br>
                        <br>

                        <div class="form-group">
                            <label class="col-md-2 control-label">Content</label>
                            <div class="col-md-10">
                                <div class="editable" id="post-body">{!! $feed->content !!}</div>
                                {{--<textarea class="form-control editable" rows="5"></textarea>--}}
                            </div>
                        </div>

                        <div class="form-group m-b-0 ">
                            <div class="col-sm-offset-3 col-sm-9 m-t-40">
                                <button type="button" class="btn btn-info waves-effect waves-light" onclick="savePost('draft')">Save as Draft</button>
                            </div>
                            <div class="col-sm-offset-3 col-sm-9 m-t-40">
                                <button type="button" class="btn btn-info waves-effect waves-light" onclick="savePost('published')">Publish Post</button>
                            </div>
                        </div>

                    </div> <!-- panel-body -->
                </div> <!-- panel -->
            </div> <!-- col -->
        </div> <!-- End row -->

        <div id="article-content" style="display: none;">

        </div>

    </div> <!-- container -->

@endsection

@section('page-js')

    <script src="{{ asset('node_modules/medium-editor/dist/js/medium-editor.js') }}"></script>
    <script src="{{ asset('node_modules/handlebars/dist/handlebars.runtime.min.js') }}"></script>
    <script src="{{ asset('node_modules/jquery-sortable/source/js/jquery-sortable-min.js') }}"></script>
    <script src="{{ asset('node_modules/blueimp-file-upload/js/vendor/jquery.ui.widget.js') }}"></script>
    <script src="http://linkesch.com/medium-editor-insert-plugin/bower_components/jquery-cycle2/build/jquery.cycle2.min.js"></script>
    <script src="http://linkesch.com/medium-editor-insert-plugin/bower_components/jquery-cycle2/build/plugin/jquery.cycle2.center.min.js"></script>
    <script src="https://blueimp.github.io/JavaScript-Load-Image/js/load-image.js"></script>
    <script src="http://blueimp.github.io/JavaScript-Canvas-to-Blob/js/canvas-to-blob.min.js"></script>
    <script src="{{ asset('node_modules/blueimp-file-upload/js/jquery.iframe-transport.js') }}"></script>
    <script src="{{ asset('node_modules/blueimp-file-upload/js/jquery.fileupload.js') }}"></script>
    <script src="{{ asset('node_modules/medium-editor-insert-plugin/dist/js/medium-editor-insert-plugin.min.js') }}"></script>

    <script type="text/javascript">

        var editor = new MediumEditor('.editable');

        $(function () {
            $('.editable').mediumInsert({
                editor: editor,
                addons: { // (object) Addons configuration
                    images: { // (object) Image addon configuration
                        label: '<span class="fa fa-camera"></span>', // (string) A label for an image addon
                        fileDeleteOptions: {}, // (object) extra parameters send on the delete ajax request, see http://api.jquery.com/jquery.ajax/
                        preview: true, // (boolean) Show an image before it is uploaded (only in browsers that support this feature)
                        captions: true, // (boolean) Enable captions
                        autoGrid: 3, // (integer) Min number of images that automatically form a grid
                        formData: {}, // DEPRECATED: Use fileUploadOptions instead
                        fileUploadOptions: { // (object) File upload configuration. See https://github.com/blueimp/jQuery-File-Upload/wiki/Options
                            url: '{{ route('article.upload') }}', // (string) A relative path to an upload script
                            limitMultiFileUploads:2,
                            acceptFileTypes: /(\.|\/)(gif|jpe?g|png)$/i // (regexp) Regexp of accepted file types
                        },
                        styles: { // (object) Available image styles configuration
                            wide: { // (object) Image style configuration. Key is used as a class name added to an image, when the style is selected (.medium-insert-images-wide)
                                label: '<span class="fa fa-align-justify"></span>', // (string) A label for a style
                                added: function ($el) {
                                }, // (function) Callback function called after the style was selected. A parameter $el is a current active paragraph (.medium-insert-active)
                                removed: function ($el) {
                                } // (function) Callback function called after a different style was selected and this one was removed. A parameter $el is a current active paragraph (.medium-insert-active)
                            },
                            left: {
                                label: '<span class="fa fa-align-left"></span>'
                            },
                            right: {
                                label: '<span class="fa fa-align-right"></span>'
                            },
                            grid: {
                                label: '<span class="fa fa-th"></span>'
                            }
                        },
                        actions: { // (object) Actions for an optional second toolbar
                            remove: { // (object) Remove action configuration
                                label: '<span class="fa fa-times"></span>', // (string) Label for an action
                                clicked: function ($el) { // (function) Callback function called when an action is selected
                                    var $event = $.Event('keydown');

                                    $event.which = 8;
                                    $(document).trigger($event);
                                }
                            }
                        },
                        messages: {
                            acceptFileTypesError: 'This file is not in a supported format: ',
                            maxFileSizeError: 'This file is too big: '
                        },
                        uploadCompleted: function ($el, data) {
                            console.log(data);
                        }, // (function) Callback function called when upload is completed
                        uploadFailed: function (uploadErrors, data) {
                            console.log(data);

                        } // (function) Callback function called when upload failed
                    }
                }
            });
        });

        function savePost(status)
        {
            var minLength = 300;
            var category;
            var postContent = editor.serialize();

            $('#article-content').html(postContent['post-body']['value']);
            var numImg = $('#article-content img').length;
            var numIframe = $('#article-content iframe').length;
            var contentLength = $('#article-content').text().length;

            if(contentLength == 0)
            {
                notify('Content Must not Be Empty!','error');
                return false;
            }

            console.log(numImg, contentLength, numIframe);

            if(numIframe > 0){
                category = 'video';
            } else if(contentLength > minLength){
                category = 'story';
            }else{
                category = 'photo';
            }

            var data = {
                title: $('#post-title').val(),
                content: postContent['post-body']['value'],
                category : category,
                featured_image: $('#featured_image').val(),
                status:status,
            };

            console.log(data);

            $.ajax({
                type: 'PATCH',
                url : "{{ route('article.update',['article' => $feed->id]) }}",
                data: data,
                success: function(data) {
                    console.log(data);
                    location.href = '{{ route('getboard')  }}';
                },
                error: function(response) {
                    handleInputErrors(response.responseText);
                }
            });
        }

        /*$('body').on('click', '#save-post', function(e){
         e.preventDefault();


         return false;
         });*/

        //Featured Image Preview.
        $("#fileupload").change(function(){
            readURL(this);
        });

        //upload Featured Image.
        $(function () {
            $('#fileupload').fileupload({
                url: '{{ route('article.upload') }}',
                dataType: 'json',
                done: function (e, data) {
                    notify('Featured Image Uploaded Successfully!','success');
                    console.log(data);
                    $('#featured_image').val(data.result.files[0].url);
                }
            });
        });

    </script>

@endsection

resources/views/article/index.blade.php
@extends('layouts.app')

@section('page-title', $article->title)


@section('page-content')
    <div class="container">
            <div class="row">
                <div class="col-lg-8">
                    <h1><a href="{{ route('article.show', ['article' => $article->id]) }}"> {{ $article->title }}</a></h1>
                    <a href="#" class="pull-right" id="bookmark" data-id="{{ $article->id }}"><i class="fa fa-bookmark"></i></a>
                    <p class="lead">
                        by <a href="#">{{ $article->user->name }}</a>
                    </p>
                    <hr>
                    <p><span class="glyphicon glyphicon-time"></span> Posted on {{ date('F d, Y', strtotime($article->updated_at)) }}</p>

                    <hr>

                    <hr>
                    {!! $article->content !!}
                    <hr>
                </div> <!-- End row -->
            </div>

    </div> <!-- container -->

@endsection

@section('page-js')
    <script type="text/javascript">
        $('#bookmark').click(function (e) {
            e.preventDefault();
            $.ajax({
                type:"GET",
                url:'{{ route('article.bookmark',['article' => $article->id]) }}',
                success:function(){
                    notify('Bookmark Successfully','success');
                },
                error:function(response){
                    handleInputErrors(response.responseText);
                }
            });
        });
    </script>

@endsection